VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cDialer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Const MAX_TRIES As Long = 10000
Private Const DIAL_DIRECT = 1
Private Const DIAL_INDIRECT = 2

Private m_TypeDialer    As Integer
Private m_CommPort      As Integer
Private m_PhoneNumber   As String
Private m_frm           As New frmDialer

'---------------------------------------------------------------------------------------
' Procedure : CleanPhoneNumber
' DateTime  : 1/23/03 13:24
' Author    : Mike Godfrey
' Purpose   : Clean the phone number, remove extraneous characters
'             like - and (, and convert letters into digits.
' Input     : Phone Number
' Returns   : Clean Phone Number as String
'---------------------------------------------------------------------------------------
'
Private Function CleanPhoneNumber(ByVal phone_number As String) As String
Dim result  As String
Dim i       As Integer

    On Error GoTo CleanPhoneNumber_Error

    For i = 1 To Len(phone_number)
        result = result & PhoneDigit(Mid$(phone_number, i, 1))
    Next i

    CleanPhoneNumber = result

ExitProc:
   Exit Function

CleanPhoneNumber_Error:
   MsgBox "Error " & Err.Number & " (" & Err.Description & ")  " & vbCrLf & _
          "in procedure CleanPhoneNumber of Class Module cDialer"
   Resume ExitProc
End Function

'---------------------------------------------------------------------------------------
' Procedure : PhoneDigit
' DateTime  : 1/23/03 13:25
' Author    : Mike Godfrey
' Purpose   : If "letter" is number, return it unchanged.
'             If "letter" is a letter, return the corresponding
'             telephone digit.
'             If "letter" is something else, return "".
' Returns   : String as Phone Number is developed
'---------------------------------------------------------------------------------------
'
Private Function PhoneDigit(ByVal letter As String) As String
   On Error GoTo PhoneDigit_Error

    letter = UCase(letter)

    If letter >= "0" And letter <= "9" Then
        PhoneDigit = letter
    ElseIf letter >= "A" And letter <= "Z" Then
        Select Case letter
            Case "A" To "C"
                PhoneDigit = 2
            Case "D" To "F"
                PhoneDigit = 3
            Case "G" To "I"
                PhoneDigit = 4
            Case "J" To "L"
                PhoneDigit = 5
            Case "M" To "O"
                PhoneDigit = 6
            Case "P" To "S"
                PhoneDigit = 7
            Case "T" To "V"
                PhoneDigit = 8
            Case "W" To "Z"
                PhoneDigit = 9
        End Select
    Else
        PhoneDigit = ""
    End If

ExitProc:
   Exit Function

PhoneDigit_Error:
   MsgBox "Error " & Err.Number & " (" & Err.Description & ")  " & vbCrLf & _
          "in procedure PhoneDigit of Class Module cDialer"
   Resume ExitProc
End Function

'---------------------------------------------------------------------------------------
' Procedure : cmdDial_Click
' DateTime  : 1/23/03 01:43
' Author    : Mike Godfrey
' Purpose   : Dial a number entered on the form or passed from calling procedure.
' Returns   : Boolean
'---------------------------------------------------------------------------------------
'
Private Function DialNumber(Optional ByVal PhoneNumber As String) As Boolean
   Dim Results    As String
   Dim Buffer     As Variant
   Dim num_tries  As Long
   Dim CommData   As Variant
   Dim lIndex     As Long
   Dim bStatus    As Boolean
   Dim delay_stop As Variant
   
   bStatus = True
   On Error GoTo DialNumber_Error
   Screen.MousePointer = vbHourglass
   DoEvents
   
   With m_frm
      ' Try to give MSComm1 time to close.
      If .MSComm1.PortOpen = True Then
         .MSComm1.PortOpen = False
      End If
      DoEvents
   
      ' Set the comm port number.  If dialing with a number set commport to 3
      ' or whatever is the appropriate port
      If m_TypeDialer = DIAL_INDIRECT Then
         .MSComm1.CommPort = CInt(.cbo(0).Text)
      Else
         .MSComm1.CommPort = m_CommPort
      End If
   
      ' Read the entire buffer when Input is used.
      .MSComm1.InputLen = 0

      ' 9600 baud, no parity, 8 data bits, 1 stop bit.
      .MSComm1.Settings = "9600,N,8,1"
   
      ' Open the comm port.
      On Error Resume Next
      .MSComm1.PortOpen = True
      ' If Comm Port is unavailable then give user message.
      If Err Then
         MsgBox "COM3: not available. Change the CommPort property to another port."
         Screen.MousePointer = vbNormal
         DoEvents
         bStatus = False
         Exit Function
      End If
   
      ' Send the attention string to the modem.
      Buffer = "ATV1Q0" & vbCr
      .MSComm1.Output = Buffer
      DoEvents
      
      'Have the program wait to allow for modem delay
      delay_stop = DateAdd("s", 3, Now)
      Do While Now < delay_stop
          DoEvents
      Loop
      
'      ' Wait for OK.
'      Do
'         ' Read the latest data from the serial port.
'         Results = .MSComm1.Input
'         num_tries = num_tries + 1
'         If num_tries > MAX_TRIES Then
'         MsgBox "Did not get OK response in " & MAX_TRIES & " tries"
'            Exit Do
'         End If
'      Loop Until InStr(Results, "OK" & vbCr) > 0
   
      ' Dial the phone number.
      ' AT is the Hayes compatible ATTENTION command and is required to send commands to the modem.
      ' DT means "Dial Tone." The Dial command uses touch tones, as opposed to pulse (DP = Dial Pulse).
      ' Numbers$ is the phone number being dialed.
      ' A semicolon tells the modem to return to command mode after dialing (important).
      ' A carriage return, vbCr, is required when sending commands to the modem.
      Select Case m_TypeDialer
         Case DIAL_INDIRECT
            ' Flush the input buffer.
            .MSComm1.InBufferCount = 0
            .MSComm1.Output = "ATDT " & CleanPhoneNumber(.PhoneNumber) & ";" & vbCr
            DoEvents
            
            'Have the program wait to allow for modem delay
            delay_stop = DateAdd("s", 2, Now)
            Do While Now < delay_stop
                DoEvents
            Loop
'            ' Waif for OK
'            num_tries = 1
'            Do
'               ' Read the latest data from the serial port.
'               Results = Results & .MSComm1.Input
'               num_tries = num_tries + 1
'               If num_tries > MAX_TRIES Then
'                  MsgBox "Did not get OK response in " & MAX_TRIES & " tries"
'                  Exit Do
'               End If
'            Loop Until InStr(Results, "OK") > 0
            
         Case DIAL_DIRECT
            ' Flush the input buffer.
            .MSComm1.InBufferCount = 0
            .MSComm1.Output = "ATDT" & CleanPhoneNumber(PhoneNumber) & ";" & vbCr
            DoEvents
            
            'Have the program wait to allow for modem delay
            delay_stop = DateAdd("s", 2, Now)
            Do While Now < delay_stop
                DoEvents
            Loop
'            ' Wait for OK
'            num_tries = 1
'            Do
'               ' Read the latest data from the serial port.
'               Results = .MSComm1.Input
'               num_tries = num_tries + 1
'               If num_tries > MAX_TRIES Then
'                  MsgBox "Did not get OK response in " & MAX_TRIES & " tries"
'                  Exit Do
'               End If
'            Loop Until InStr(Results, "OK") > 0
      End Select
   
      ' Ask the user to wait until the phone rings.
      MsgBox "If you hear a busy signal, click OK." & vbCrLf & _
             "When you hear a ringing signal, pick up the receiver and click OK.", _
             vbInformation Or vbOKOnly, "Please Wait"
   
      ' Disconnect the modem.
      .MSComm1.Output = "ATH" + vbCr
      ' Close the serial port.
      .MSComm1.PortOpen = False
      Screen.MousePointer = vbDefault
   End With
   Exit Function

ExitProc:
   DialNumber = bStatus
   Exit Function

DialNumber_Error:
   bStatus = False
   Screen.MousePointer = vbDefault
   MsgBox "Error " & Err.Number & " (" & Err.Description & ")  " & vbCrLf & _
          "in procedure DialNumber of Class Module cDialer"
   Resume ExitProc
End Function


'---------------------------------------------------------------------------------------
' Procedure : ShowLoginScreen
' DateTime  : 1/23/03 01:41
' Author    : Mike Godfrey
' Purpose   : Displays the Dialer form to the user.
' Returns   : Boolean
'---------------------------------------------------------------------------------------
'
Private Function ShowDialerScreen() As Boolean
   Dim bStatus  As Boolean   'Procedure Status
   
   On Error GoTo ShowDialerScreen_Error
   bStatus = True

   With m_frm
      If m_TypeDialer = DIAL_INDIRECT Then
         .Show vbModal
            ' --------------------------------------------------------------------
            ' User pressed Dial.
            ' --------------------------------------------------------------------
         If .OKPressed = True Then
            bStatus = DialNumber
         Else
            ' --------------------------------------------------------------------
            ' User pressed Cancel.
            ' --------------------------------------------------------------------
            Set m_frm = Nothing
            bStatus = False
         End If
      End If
   End With
      
ExitProc:
   ShowDialerScreen = bStatus
   Exit Function

ShowDialerScreen_Error:
   bStatus = False
   MsgBox "Error " & Err.Number & " (" & Err.Description & ")  " & vbCrLf & _
          "in procedure ShowLoginScreen of Form frmDialer"
   Resume ExitProc
   
End Function

'---------------------------------------------------------------------------------------
' Procedure : Dial
' DateTime  : 1/23/03 13:32
' Author    : Mike Godfrey
' Purpose   : Entrance to cDialer
'             If the calling procedure passes a phone number go directly to 'CleanPhoneNumber'
'             and do not show the form.  If the calling procedure requires an input of a
'             phone number, show the form to allow for input
' Input     : iTypeDialer = 1 - go directly to 'CleanPhoneNumber
'             iTypeDialer = 2 - show the form for input
'             strPhoneNumber - phone number to dial if iTypeDialer = 1
'             iCommPort - Comm Port number if iTypeDialer = 1
' Returns   : Boolean
'---------------------------------------------------------------------------------------
'
Public Function Dial(ByVal iTypeDialer As Integer, _
            Optional ByVal strPhoneNumber As String, _
            Optional ByVal iCommPort As Integer) As Boolean
   Dim bStatus As Boolean
   Dim bResult As Boolean

   On Error GoTo Dial_Error
   m_TypeDialer = iTypeDialer
   bStatus = True
   
   Select Case iTypeDialer
      Case 1
         m_CommPort = iCommPort
         bResult = ShowDialerScreen
         bResult = DialNumber(strPhoneNumber)
      Case 2
         bResult = ShowDialerScreen
      Case Else
         bStatus = False
   End Select

ExitProc:
   Dial = bStatus
   Exit Function

Dial_Error:
   bStatus = False
   MsgBox "Error " & Err.Number & " (" & Err.Description & ")  " & vbCrLf & _
          "in procedure Dial of Class Module cDialer"
   Resume ExitProc
End Function

Private Sub Class_Terminate()
   Set m_frm = Nothing
End Sub
